<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2020 osCommerce
   Updated by Foster 04/01/2020  
  Released under the GNU General Public License
*/

  class bm_ticket {
    var $code = 'bm_ticket';
    var $group = 'boxes';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->title = MODULE_BOXES_TICKET_TITLE;
      $this->description = MODULE_BOXES_TICKET_DESCRIPTION;

      if ( defined('MODULE_BOXES_TICKET_STATUS') ) {
        $this->sort_order = MODULE_BOXES_TICKET_SORT_ORDER;
        $this->enabled = (MODULE_BOXES_TICKET_STATUS == 'True');

        $this->group = ((MODULE_BOXES_TICKET_CONTENT_PLACEMENT == 'Left Column') ? 'boxes_column_left' : 'boxes_column_right');
      }
    }

    function execute() {
      global $oscTemplate, $languages_id;

	$bm_ticket_links = null;
      foreach (MODULE_BOXES_TICKET_BOX_DATA as $a => $b) {
        $bm_ticket_links .= '<a class="list-group-item list-group-item-action" href="' . tep_href_link($a) . '">' . $b . '</a>' . PHP_EOL; 
	}

      ob_start();
      include('includes/modules/boxes/templates/tpl_' . basename(__FILE__));
      $data = ob_get_clean();

      $oscTemplate->addBlock($data, $this->group);
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_BOXES_TICKET_STATUS');
    }

    function install() {
	if (tep_db_num_rows(tep_db_query('SHOW TABLES LIKE "ticket_admins"')) != 1) {
		tep_db_query("CREATE TABLE ticket_admins (ticket_admin_id int(11) NOT NULL default '0', ticket_language_id int(11) NOT NULL default '0', ticket_admin_name varchar(255) NOT NULL default '', PRIMARY KEY (ticket_admin_id,ticket_language_id)) CHARACTER SET utf8 COLLATE utf8_unicode_ci;");
		tep_db_query("INSERT INTO ticket_admins (ticket_admin_id, ticket_language_id, ticket_admin_name) VALUES (1, 1, 'John Doe<br>Support'), (1, 2, 'John Doe<br>Support'), (1, 3, 'John Doe<br>Support')");
	}	

	if (tep_db_num_rows(tep_db_query('SHOW TABLES LIKE "ticket_department"')) != 1) {
		tep_db_query("CREATE TABLE ticket_department (ticket_department_id int(5) NOT NULL default '0', ticket_language_id int(11) NOT NULL default '0', ticket_department_name varchar(60) NOT NULL default '', PRIMARY KEY (ticket_department_id,ticket_language_id)) CHARACTER SET utf8 COLLATE utf8_unicode_ci;");
		tep_db_query("INSERT INTO ticket_department (ticket_department_id, ticket_language_id, ticket_department_name) VALUES (2, 3, 'Affiliate'), (1, 3, 'Verkauf'), (1, 1, 'Sale'), (1, 2, 'Sale'), (2, 1, 'Affiliate'), (2, 2, 'Affiliate')");
	}	

	if (tep_db_num_rows(tep_db_query('SHOW TABLES LIKE "ticket_priority"')) != 1) {
		tep_db_query("CREATE TABLE ticket_priority (ticket_priority_id int(11) NOT NULL default '0', ticket_language_id int(11) NOT NULL default '0', ticket_priority_name varchar(60) NOT NULL default '', PRIMARY KEY (ticket_priority_id,ticket_language_id)) CHARACTER SET utf8 COLLATE utf8_unicode_ci;");
		tep_db_query("INSERT INTO ticket_priority (ticket_priority_id, ticket_language_id, ticket_priority_name) VALUES (1, 1, 'High'), (1, 2, 'High'), (1, 3, 'Hoch'), (2, 1, 'Low'), (2, 2, 'Low'), (2, 3, 'Low')");
	}

	if (tep_db_num_rows(tep_db_query('SHOW TABLES LIKE "ticket_reply"')) != 1) {
		tep_db_query("CREATE TABLE ticket_reply (ticket_reply_id int(11) NOT NULL default '0', ticket_language_id int(11) NOT NULL default '0', ticket_reply_name varchar(255) NOT NULL default '', ticket_reply_text text NOT NULL default '', PRIMARY KEY (ticket_reply_id,ticket_language_id)) CHARACTER SET utf8 COLLATE utf8_unicode_ci;");
		tep_db_query("INSERT INTO ticket_reply (ticket_reply_id, ticket_language_id, ticket_reply_name, ticket_reply_text) VALUES (1, 1, 'A Reply', 'This is a reply you can insert by pressing a button'), (1, 2, 'Eine Antwort', 'Dies ist eine Antwort die per Knopfdruck eingespielt werden kann'), (1, 3, 'A Reply', 'This is a reply you can insert by pressing a button')");
	}

	if (tep_db_num_rows(tep_db_query('SHOW TABLES LIKE "ticket_status"')) != 1) {
		tep_db_query("CREATE TABLE ticket_status (ticket_status_id int(5) NOT NULL default '0', ticket_language_id int(11) NOT NULL default '0', ticket_status_name varchar(60) NOT NULL default '', PRIMARY KEY (ticket_status_id,ticket_language_id)) CHARACTER SET utf8 COLLATE utf8_unicode_ci;");
		tep_db_query("INSERT INTO ticket_status (ticket_status_id, ticket_language_id, ticket_status_name) VALUES (1, 1, 'Open'), (1, 2, 'Open'), (1, 3, 'Offen'), (2, 1, 'Closed'), (2, 2, 'Closed'), (2, 3, 'Geschlossen')");
	}

	if (tep_db_num_rows(tep_db_query('SHOW TABLES LIKE "ticket_status_history"')) != 1) {
		tep_db_query("CREATE TABLE ticket_status_history (ticket_status_history_id int(11) NOT NULL auto_increment, ticket_id int(11) NOT NULL default '0', ticket_status_id int(5) NOT NULL default '0', ticket_priority_id int(5) NOT NULL default '0', ticket_department_id int(5) NOT NULL default '0', ticket_date_modified datetime NOT NULL default '0000-00-00 00:00:00', ticket_customer_notified int(1) default '0', ticket_comments text, ticket_edited_by varchar(64) NOT NULL default '', PRIMARY KEY (ticket_status_history_id)) CHARACTER SET utf8 COLLATE utf8_unicode_ci;");
	}

	if (tep_db_num_rows(tep_db_query('SHOW TABLES LIKE "ticket_ticket"')) != 1) {
		tep_db_query("CREATE TABLE ticket_ticket (ticket_id int(11) NOT NULL auto_increment, ticket_link_id varchar(32) NOT NULL default '', ticket_customers_id int(12) NOT NULL default '0', ticket_customers_orders_id int(11) NOT NULL default '0', ticket_customers_email varchar(96) NOT NULL default '', ticket_customers_name varchar(96) NOT NULL default '', ticket_subject varchar(96) NOT NULL default '', ticket_status_id int(5) NOT NULL default '0', ticket_department_id int(5) NOT NULL default '0', ticket_priority_id int(5) NOT NULL default '0', ticket_date_created datetime NOT NULL default '0000-00-00 00:00:00', ticket_date_last_modified datetime NOT NULL default '0000-00-00 00:00:00', ticket_date_last_customer_modified datetime NOT NULL default '0000-00-00 00:00:00', ticket_login_required tinyint(4) NOT NULL default '0', PRIMARY KEY  (ticket_id)) CHARACTER SET utf8 COLLATE utf8_unicode_ci;");
	}

	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Ticket Module', 'MODULE_BOXES_TICKET_STATUS', 'True', 'Do you want to add the module to your shop?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Placement', 'MODULE_BOXES_TICKET_CONTENT_PLACEMENT', 'Left Column', 'Should the module be loaded in the left or right column?', '6', '1', 'tep_cfg_select_option(array(\'Left Column\', \'Right Column\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_BOXES_TICKET_SORT_ORDER', '900', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Delete the database tables when removing this module', 'MODULE_BOXES_TICKET_DELETE_TABLES', 'False', 'Do you want to delete the tables that were created by this module?<br><i>Note: All created data will be deleted!</i>', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Default Reply Admin For Tickets', 'TICKET_DEFAULT_ADMIN_ID', '1', 'When you reply to ticket, this is the default person assigned to it.', '8288', '0', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Default Reply For Tickets', 'TICKET_DEFAULT_REPLY_ID', '1', 'When you reply to ticket, this answer is preselected.', '8288', '0', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Default Ticket Status For Tickets', 'TICKET_DEFAULT_STATUS_ID', '1', 'When a new ticket is created, this ticket status will be assigned to it.', '8288', '0', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Default Ticket Status for replies', 'TICKET_CUSTOMER_REPLY_STATUS_ID', '1', 'When a customer replies to ticket, this ticket status will be assigned to it.', '8288', '0', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Default Department For Tickets', 'TICKET_DEFAULT_DEPARTMENT_ID', '1', 'When a new department is created, this department will be assigned to it.', '8288', '0', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Default Priority For Tickets', 'TICKET_DEFAULT_PRIORITY_ID', '1', 'When a new ticket is created, this priority will be assigned to it.', '8288', '0', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Status', 'TICKET_CATALOG_USE_STATUS', 'true', 'Show status in catalog', '8288', '1', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Customer change status?', 'TICKET_ALLOW_CUSTOMER_TO_CHANGE_STATUS', 'true', 'Allow customer to change status when replying', '8288', '2', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Department', 'TICKET_CATALOG_USE_DEPARTMENT', 'true', 'Use Department in Catalog?', '8288', '3', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Customer change department?', 'TICKET_ALLOW_CUSTOMER_TO_CHANGE_DEPARTMENT', 'true', 'Allow Customer to change department when replying?', '8288', '4', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Priority', 'TICKET_CATALOG_USE_PRIORITY', 'true', 'Use Priority in Catalog?', '8288', '5', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Customer change priority?', 'TICKET_ALLOW_CUSTOMER_TO_CHANGE_PRIORITY', 'true', 'Allow Customer to change priority when replying?', '8288', '6', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Customer order IDs', 'TICKET_SHOW_CUSTOMERS_ORDER_IDS', 'true', 'If customer is logged in, his order ids are shown', '8288', '7', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Subject', 'TICKET_SHOW_CUSTOMERS_SUBJECT', 'true', 'Show Subject ', '8288', '7', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Only logged in customer sees tickets', 'TICKET_CUSTOMER_LOGIN_REQUIREMENT_DEFAULT', '1', 'If you want to enhance security, so that registered customers have to be logged in to view the ticket set this to 1 (Changing the value only effects new tickets, its also possible to change the value via Admin for each ticket)', '8288', '8', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Minimum Reply Length', 'TICKET_ENTRIES_MIN_LENGTH', '5', 'When you reply this is the minimum number of characters you can use.', '8288', '9', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Ticket Admin Name', 'TICKET_ADMIN_NAME', 'Admin', 'The name of the admin', '8288', '10', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Admin use status?', 'TICKET_USE_STATUS', 'true', 'Allow admin to change status of ticket?', '8288', '11', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Admin use department?', 'TICKET_USE_DEPARTMENT', 'true', 'Allow admin to change department of ticket?', '8288', '12', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Admin use priority?', 'TICKET_USE_PRIORITY', 'true', 'Allow admin to change priority of ticket?', '8288', '13', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Admin use order IDs?', 'TICKET_USE_ORDER_IDS', 'true', 'Allow admin to use and/or change order IDs for tickets?', '8288', '14', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Admin use subject?', 'TICKET_USE_SUBJECT', 'true', 'Allow admin to use and/or change subject for tickets?', '8288', '15', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
	tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Admin - customer login requirement', 'TICKET_CHANGE_CUSTOMER_LOGIN_REQUIREMENT', 'true', 'Change the use of Customer login reguirment default per ticket via admin. If you set this to true you can allow / notallow registered customers to view tickets without being logged in', '8288', '16', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
    }

    function remove() {
	tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
	if(MODULE_BOXES_TICKET_DELETE_TABLES == True){ //drop tables if delete_tables option is true

	tep_db_query("drop table if exists ticket_admins");
	tep_db_query("drop table if exists ticket_department");
	tep_db_query("drop table if exists ticket_priority");
	tep_db_query("drop table if exists ticket_reply");
	tep_db_query("drop table if exists ticket_status");
	tep_db_query("drop table if exists ticket_status_history");
	tep_db_query("drop table if exists ticket_ticket");

      }
    }

    function keys() {
      return array('MODULE_BOXES_TICKET_STATUS', 'MODULE_BOXES_TICKET_CONTENT_PLACEMENT', 'MODULE_BOXES_TICKET_SORT_ORDER', 'MODULE_BOXES_TICKET_DELETE_TABLES', 'TICKET_DEFAULT_ADMIN_ID', 'TICKET_DEFAULT_REPLY_ID', 'TICKET_DEFAULT_STATUS_ID', 'TICKET_CUSTOMER_REPLY_STATUS_ID', 'TICKET_DEFAULT_DEPARTMENT_ID', 'TICKET_DEFAULT_PRIORITY_ID', 'TICKET_CATALOG_USE_STATUS', 'TICKET_ALLOW_CUSTOMER_TO_CHANGE_STATUS', 'TICKET_CATALOG_USE_DEPARTMENT', 'TICKET_ALLOW_CUSTOMER_TO_CHANGE_DEPARTMENT', 'TICKET_CATALOG_USE_PRIORITY', 'TICKET_ALLOW_CUSTOMER_TO_CHANGE_PRIORITY', 'TICKET_SHOW_CUSTOMERS_ORDER_IDS', 'TICKET_SHOW_CUSTOMERS_SUBJECT', 'TICKET_CUSTOMER_LOGIN_REQUIREMENT_DEFAULT', 'TICKET_ENTRIES_MIN_LENGTH', 'TICKET_ADMIN_NAME', 'TICKET_USE_STATUS', 'TICKET_USE_DEPARTMENT', 'TICKET_USE_PRIORITY', 'TICKET_USE_ORDER_IDS', 'TICKET_USE_SUBJECT', 'TICKET_CHANGE_CUSTOMER_LOGIN_REQUIREMENT');
    }
  }
