<?php
/*
  $Id: ticket_create.php,v 1.5 2003/04/25 21:37:12 hook Exp $

  OSC-SupportTicketSystem
  Copyright (c) 2003 Henri Schmidhuber IN-Solution
   Updated by Foster 04/01/2020  
 
  Contribution based on:

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  require('includes/application_top.php');

  //if (!tep_session_is_registered('customer_id') && $_GET['login']=="yes") {
  if (!tep_session_is_registered('customer_id')) {
    $navigation->set_snapshot();
    tep_redirect(tep_href_link('login.php', '', 'SSL'));
  }


  require('includes/languages/' . $language . '/ticket_create.php');
  
  // Settings:
  define ('TICKET_ENTRIES_MIN_LENGTH','5');  // Min Length of the Entries
  
  define('TICKET_CATALOG_USE_STATUS','true'); // Show status in catalog
  define('TICKET_ALLOW_CUSTOMER_TO_CHANGE_STATUS','false'); // Allow customer to change status when replying
  define('TICKET_CATALOG_USE_DEPARTMENT','true');  // Use Department in Catalog
  define('TICKET_ALLOW_CUSTOMER_TO_CHANGE_DEPARTMENT','true');  // Allow Customer to change department when replying
  define('TICKET_CATALOG_USE_PRIORITY','true');  // Use Priority in Catalog
  define('TICKET_ALLOW_CUSTOMER_TO_CHANGE_PRIORITY','true'); // Alloe Customer to change priority when replyng
  define('TICKET_SHOW_CUSTOMERS_ORDER_IDS','true');  // If customer is logged in, his orderid's are shown 
  define('TICKET_SHOW_CUSTOMERS_SUBJECT','true');  // Show Subject 
	  
  $ticket_departments = array();
  $ticket_department_array = array();
  $ticket_department_query = tep_db_query("select ticket_department_id, ticket_department_name from ticket_department where ticket_language_id = '" . $languages_id . "'");
  while ($ticket_department = tep_db_fetch_array($ticket_department_query)) {
    $ticket_departments[] = array('id' => $ticket_department['ticket_department_id'],
    'text' => $ticket_department['ticket_department_name']);
    $ticket_department_array[$ticket_department['ticket_department_id']] = $ticket_department['ticket_department_name'];
  }
  $ticket_prioritys = array();
  $ticket_priority_array = array();
  $ticket_priority_query = tep_db_query("select ticket_priority_id, ticket_priority_name from ticket_priority where ticket_language_id = '" . $languages_id . "'");
  while ($ticket_priority = tep_db_fetch_array($ticket_priority_query)) {
    $ticket_prioritys[] = array('id' => $ticket_priority['ticket_priority_id'],
    'text' => $ticket_priority['ticket_priority_name']);
    $ticket_priority_array[$ticket_priority['ticket_priority_id']] = $ticket_priority['ticket_priority_name'];
  }
 
  $email = tep_db_prepare_input(trim($_POST['email']));
  $name = tep_db_prepare_input($_POST['name']);
  $subject = tep_db_prepare_input($_POST['subject']);
  $enquiry = tep_db_prepare_input($_POST['enquiry']);
  $department = tep_db_prepare_input($_POST['department']);
  $priority = tep_db_prepare_input($_POST['priority']);
  $ticket_customers_orders_id = tep_db_prepare_input($_POST['ticket_customers_orders_id']);
  
  
// Customer is logged in:  
  if (tep_session_is_registered('customer_id')) {
	$customer_query = tep_db_query("select customers_firstname, customers_lastname, customers_email_address from customers where customers_id = '" . (int)$customer_id . "'");
    $customer = tep_db_fetch_array($customer_query);
  }

// Form was submitted
  $error = false;
  if (isset($_GET['action']) && ($_GET['action'] == 'send')) {
  // Check Name length
    if (!tep_session_is_registered('customer_id') && isset($name) && strlen($name) < TICKET_ENTRIES_MIN_LENGTH ) {
        $error = true;
        $error_name = true;
      }
    
 // Check Subject length
    if (isset($subject) && strlen($subject) < TICKET_ENTRIES_MIN_LENGTH ) {
        $error = true;
        $error_subject = true;
      }
  // Check Message length
    if (isset($enquiry) && strlen($enquiry) < TICKET_ENTRIES_MIN_LENGTH ) {
        $error = true;
        $error_enquiry = true;
      }
  // Check Email for non logged in Customers
    if (!tep_session_is_registered('customer_id') && !tep_validate_email($email)) {
      $error = true;
      $error_email = true;
    } 
    
    if ($error == false) {
      $ticket_customers_id = '';
    // Get the customers_id
      if (tep_session_is_registered('customer_id')) {
        $ticket_customers_id = $customer_id;
      } else {
        $customerid_query = tep_db_query("select customers_id from customers where customers_email_address='" . tep_db_input($email) . "'");
        if ($customerid = tep_db_fetch_array($customerid_query)) $ticket_customers_id = $customerid['customers_id'] ;
      }
      // generate LInkID
      $time = time();
      $ticket_link_id = '';
      for ($x=3;$x<10;$x++) {
        $ticket_link_id .= substr($time,$x,1) . tep_create_random_value(1, $type = 'chars');
      }
      
      $sql_data_array = array('ticket_link_id' => $ticket_link_id,
	'ticket_customers_id' => $ticket_customers_id,
	'ticket_customers_orders_id' => $ticket_customers_orders_id,
	'ticket_customers_email' => $email,
	'ticket_customers_name' => $name,
	'ticket_subject' => $subject,
	'ticket_status_id' => TICKET_DEFAULT_STATUS_ID,
	'ticket_department_id' => $department,
	'ticket_priority_id' => $priority,
	'ticket_login_required' => TICKET_CUSTOMER_LOGIN_REQUIREMENT_DEFAULT,
	'ticket_date_last_modified' => 'now()',
	'ticket_date_last_customer_modified' => 'now()',
	'ticket_date_created' => 'now()');
      tep_db_perform('ticket_ticket', $sql_data_array);
      $insert_id = tep_db_insert_id();
      
      $sql_data_array = array('ticket_id' => $insert_id,
	'ticket_status_id' => TICKET_DEFAULT_STATUS_ID,
	'ticket_priority_id' => $priority,
	'ticket_department_id' => $department,
	'ticket_date_modified' => 'now()',
	'ticket_customer_notified' => '1',
	'ticket_edited_by' => $name,
	'ticket_comments' => $enquiry);
      tep_db_perform('ticket_status_history', $sql_data_array); 
    // Email  Customer doesn't get the Message cause he should use the web
      $ticket_email_subject = TICKET_EMAIL_SUBJECT . $subject;
      $ticket_email_message = TICKET_EMAIL_MESAGE_HEADER . "\n\n" . tep_href_link('ticket_view.php', 'tlid=' . $ticket_link_id, 'NONSSL',false,false) . "\n\n" . TICKET_EMAIL_TICKET_NR . " " . $ticket_link_id . "\n" . TICKET_EMAIL_MESAGE_FOOTER;
      tep_mail($name, $email, $ticket_email_subject, nl2br($ticket_email_message), STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
    // send emails to other people
      if (SEND_EXTRA_ORDER_EMAILS_TO != '') {
       $ticket_email_message = TICKET_EMAIL_MESAGE_HEADER . "\n\n" . tep_href_link('ticket_view.php', 'tlid=' . $ticket_link_id) . "\n\n" . $enquiry . TICKET_EMAIL_MESAGE_FOOTER . "\n\n" . $enquiry;
       tep_mail('', SEND_EXTRA_ORDER_EMAILS_TO, $ticket_email_subject,nl2br($ticket_email_message), STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
      }
      tep_redirect(tep_href_link('ticket_create.php', 'action=success&tlid=' . $ticket_link_id ));
    }
  }


  $breadcrumb->add(NAVBAR_TITLE, tep_href_link('ticket_create.php'));

  require('includes/template_top.php');
?>
<h1 class="display-4"><?php echo HEADING_TITLE; ?></h1>


<div class="contentContainer">
  <div class="contentText">
    <table border="0" width="100%" cellspacing="3" cellpadding="3">
<?php
  if (isset($_GET['action']) && ($_GET['action'] == 'success')) {
?>

<div class="contentContainer">
	<div class="contentText">
	<div class="alert alert-success" role="alert"><?php echo TEXT_SUCCESS; ?></div>
	<div>
	<p><?php echo TEXT_YOUR_TICKET_ID . ' ' . $_GET['tlid']; ?></p>
	<p><?php echo TEXT_CHECK_YOUR_TICKET . '<br><a href="' . tep_href_link('ticket_view.php', 'tlid=' . $_GET['tlid'], 'NONSSL',false,false) . '">' . tep_href_link('ticket_view.php', 'tlid=' . $_GET['tlid'], 'NONSSL',false,false) . '</a>'; ?></p>
	<div class="buttonSet">
<div class="text-right"><?php echo tep_draw_button(IMAGE_BUTTON_CONTINUE, 'fas fa-angle-right', tep_href_link('index.php'), null, null, 'btn-light btn-block btn-lg'); ?></div>
	</div>
	</div>
	</div>
	</div>
<?php
  } else {
?>
<?php echo tep_draw_form('contact_us', tep_href_link('ticket_create.php', 'action=send')); ?>
	<div class="contentContainer">
	<div class="contentText">
	<div><?php
	if (!tep_session_is_registered('customer_id')) {
	echo  sprintf(TEXT_LOGIN, tep_href_link('ticket_create.php', 'login=yes', 'SSL'), tep_href_link('create_account.php', '', 'SSL')); 
   }
   ?>
</div>
<p class="text-danger text-right"><?php echo FORM_REQUIRED_INFORMATION; ?></p>
  <div class="w-100"></div>

<div class="form-group row">
    <label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo ENTRY_NAME; ?></label>
    <div class="col-sm-9">
    <?php
	if (tep_session_is_registered('customer_id')) { 
	echo tep_draw_input_field('name', $customer['customers_firstname'] . ' ' . $customer['customers_lastname'], 'required autofocus="autofocus" aria-required="true" id="inputFromName" placeholder="' . ENTRY_NAME . '"');
	echo FORM_REQUIRED_INPUT;
} else {
	echo tep_draw_input_field('name', NULL, 'required autofocus="autofocus" aria-required="true" id="inputFromName" placeholder="' . ENTRY_NAME_TEXT . '"');
	echo FORM_REQUIRED_INPUT;
}
?>
</div>
</div>
<div class="form-group row">
  <label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo ENTRY_EMAIL; ?></label>
  <div class="col-sm-9">

	<?php
	if (tep_session_is_registered('customer_id')) {
	echo tep_draw_input_field('email', $customer['customers_email_address'], 'required aria-required="true" id="inputFromEmail" placeholder="' . ENTRY_EMAIL_ADDRESS_TEXT . '"', 'email');
	echo FORM_REQUIRED_INPUT;
	} else {
	echo tep_draw_input_field('email', NULL, 'required aria-required="true" id="inputFromEmail" placeholder="' . ENTRY_EMAIL_ADDRESS_TEXT . '"', 'email');
	echo FORM_REQUIRED_INPUT;
}
?>
</div>
</div>
<?php
    if (TICKET_SHOW_CUSTOMERS_SUBJECT == 'true') {
?>
<div class="form-group row">
<label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo ENTRY_SUBJECT; ?></label>
<div class="col-sm-9">
	<?php
	echo tep_draw_input_field('subject', NULL, 'required autofocus="autofocus" aria-required="true" id="inputSubject" placeholder="' . ENTRY_SUBJECT_TEXT . '"');
	echo FORM_REQUIRED_INPUT;

?>
</div>
</div>
<?php
}
	if (TICKET_SHOW_CUSTOMERS_ORDER_IDS == 'true' && tep_session_is_registered('customer_id')) {     
	$customers_orders_query = tep_db_query("select orders_id, date_purchased from orders where customers_id = '" . tep_db_input($customer_id) . "'");
	if (isset($_GET['ticket_order_id'])) $ticket_preselected_order_id = $_GET['ticket_order_id'];
	$orders_array[] = array('id' => '', 'text' => ' -- ' );
	while ($customers_orders = tep_db_fetch_array($customers_orders_query)) {
	$orders_array[] = array('id' => $customers_orders['orders_id'], 'text' => $customers_orders['orders_id'] . "  (" . tep_date_short($customers_orders['date_purchased']) . ")" );
}

?>
<div class="form-group row">
	<label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo ENTRY_ORDER; ?></label>
	<div class="col-sm-9">
<?php
	echo tep_draw_pull_down_menu('ticket_customers_orders_id', $orders_array,$ticket_preselected_order_id); ?>
</div>
</div>

<?php
}
	if (TICKET_CATALOG_USE_DEPARTMENT == 'true') {     
?>
<div class="form-group row">
<label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo ENTRY_DEPARTMENT; ?></label>
	<div class="col-sm-9">
<?php
	echo tep_draw_pull_down_menu('department', $ticket_departments, ($department ? $department : TICKET_DEFAULT_DEPARTMENT_ID) ); ?>
</div>
</div>
<?php
} else {
	echo tep_draw_hidden_field('department', TICKET_DEFAULT_DEPARTMENT_ID);
}
	if (TICKET_CATALOG_USE_PRIORITY == 'true') {   
?>
	<div class="form-group row">
    <label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo ENTRY_PRIORITY; ?></label>
<div class="col-sm-9">
<?php echo tep_draw_pull_down_menu('priority', $ticket_prioritys, ($priority ? $priority : TICKET_DEFAULT_PRIORITY_ID) ); ?>
</div>
</div>
<?php
} else {
      echo tep_draw_hidden_field('priority', TICKET_DEFAULT_PRIORITY_ID);
    }
?>
    <div class="form-group row">
    <label for="inputFromName" class="col-sm-3 col-form-label text-right"><?php echo ENTRY_ENQUIRY; ?></label>
    <div class="col-sm-9">
        <?php
        echo tep_draw_textarea_field('enquiry', 'soft', 50, 15, $enquiry, 'required aria-required="true" id="inputEnquiry" placeholder="' . ENTRY_ENQUIRY_TEXT . '"');
        echo FORM_REQUIRED_INPUT;
        ?>
      </div>
    </div>
  </div>

  <div class="buttonSet">
    <div class="text-right"><?php echo tep_draw_button(SUBMIT_TICKET_BUTTON_TEXT, 'fas fa-paper-plane', null, 'primary', null, 'btn-success btn-block btn-lg'); ?></div>
  </div>
</div>
</form>

<?php
  }
?>
    </table>
  </div>

</div>

<?php
  require('includes/template_bottom.php');
  require('includes/application_bottom.php');
?>
